      SUBROUTINE CENMOM(RAW,CEN,SKEW,EKURT)
C  This routine computes the first four central moments, skewness and
C  excess kurtosis of a distribution, given the first four raw moments.
C  Inputs:
C  RAW(4)    First four raw moments
C  Outputs:
C  CEN(4)    First four central moments
C  SKEW      Skewness coefficient
C  EKURT     Excess kurtosis
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION RAW(4),CEN(4)
      AMU=RAW(1)
      CEN(1)=0.0D0
      CEN(2)=RAW(2)-RAW(1)**2
      CEN(3)=RAW(3)-3.0D0*AMU*RAW(2)+2.0D0*AMU**3
      CEN(4)=RAW(4)-4.0D0*AMU*RAW(3)+6.0D0*(AMU**2)*RAW(2)-3.0D0*AMU**4
      SKEW=CEN(3)/CEN(2)**1.5D0
      EKURT=CEN(4)/CEN(2)**2-3.0D0
      RETURN
      END
