      SUBROUTINE PRSYM(HTITLE,N,A,LDA)
C  This routine prints the lower triangle of a symmetric n x n matrix.
C  Inputs:
C  HTITLE   Header to identify matrix
C  N        Order of matrix, n
C  A        Matrix
C  LDA      Leading dimension of matrix
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*(*) HTITLE
      DIMENSION A(LDA,N)
      WRITE(6,5)HTITLE
    5 FORMAT(/,1X,A)
      DO 20 IC=1,N,5
      NR1=IC
      NR2=N
      NC1=IC
      NC2=IC+4
      IF(NC2.GT.N)NC2=N
      WRITE(6,10)(NC,NC=NC1,NC2)
   10 FORMAT(/,5I15)
      DO 20 IR=NR1,NR2
      NCA=NC2
      IF(NC2.GT.IR)NCA=IR
   20 WRITE(6,30)IR,(A(IR,J),J=NC1,NCA)
   30 FORMAT(I4,5(1PE15.6))
      RETURN
      END
      SUBROUTINE PRCOR(HTITLE,N,A,LDA)
C  This routine prints the normalized lower triangle of a symmetric n x n 
C  matrix; e.g., it converts a variance matrix to a correlation matrix before
C  printing.
C  Inputs:
C  HTITLE   Header to identify matrix
C  N        Order of matrix, n
C  A        Matrix
C  LDA      Leading dimension of matrix
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*(*) HTITLE
      DIMENSION A(LDA,N)
      PARAMETER(LD=100)
      COMMON/SCRA/V1(LD),V2(LD),A1(LD,LD),A2(LD,LD)
      WRITE(6,5)HTITLE
    5 FORMAT(/,1X,A)
      DO 20 IC=1,N,10
      NR1=IC
      NR2=N
      NC1=IC
      NC2=IC+9
      IF(NC2.GT.N)NC2=N
      WRITE(6,10)(NC,NC=NC1,NC2)
   10 FORMAT(/I10,9I7)
      DO 20 IR=NR1,NR2
      V1(IR)=DSQRT(A(IR,IR))
      NCA=NC2
      IF(NC2.GT.IR)NCA=IR
   20 WRITE(6,30)IR,(A(IR,J)/(V1(IR)*V1(J)),J=NC1,NCA)
   30 FORMAT(I5,10F7.3)
      RETURN
      END
