      DOUBLE PRECISION FUNCTION PTDF(AMU,H,ANU,X)
C  This function evaluates the c.d.f. of a Student t distribution
C  Inputs:
C  AMU      Location parameter of Student t
C  H        Inverse of squared scale parameter of Student t
C  ANU      Degrees of freedom parameter of Student t
C  X        Point of evaluation
C  Output:
C  PTDF     Value of c.d.f.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      T=(X-AMU)*DSQRT(H)
      PTDF=DTDF(T,ANU)
      RETURN
      END
