      SUBROUTINE QUANT(N,NQ,W,G,P,Q)
C  From the sampled distribution of a random variable, compute quantiles.
C  Inputs:
C  N       Size of sample
C  NQ      Number of quantiles to compute
C  W(Nx1)  Vector of log weights
C  G(Nx1)  Sampled random variables
C  P(NQx1) Probabilities corresponding to quantiles
C  Outputs:
C  Q(NQx1) Quantiles
C  W(Nx1)  Actual weights, unless all log weights were 0
C  G(Nx1)  Ordered random variables
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER(LD=10000)
      DIMENSION W(N),G(N),P(NQ),Q(NQ)
      DIMENSION NV(LD)
      IF(DASUM(N,W,1).GT.0.0D0)GO TO 20
C  Procedure for weights the same --
      CALL DSVRGN(N,G,G)
      DO 10 IQ=1,NQ
      JQ=P(IQ)*N+1
   10 Q(IQ)=G(JQ)
      RETURN
C  Procedure for different weights --
   20 WMAX=W(IDMAX(N,W,1))
      WTOT=0.0D0
      DO 30 I=1,N
      NV(I)=I
      AA=0.0D0
      IF(W(I).GT.-700.0D0)AA=DEXP(W(I)-WMAX)
      W(I)=AA
   30 WTOT=WTOT+AA
      CALL DSVRGP(N,G,G,NV)
      JQ=1
      WCUT=P(1)*WTOT
      WRUN=0.0D0
      DO 50 I=1,N
      WRUN=WRUN+W(NV(I))
   40 IF(WRUN.LT.WCUT)GO TO 50
      Q(JQ)=G(I)
      JQ=JQ+1
      IF(JQ.GT.NQ)RETURN
      WCUT=P(JQ)*WTOT
      GO TO 40
   50 CONTINUE
      DO 60 IQ=JQ,NQ
   60 Q(IQ)=G(N)
      RETURN
      END 
