      SUBROUTINE UCROSS(NRA,NCA,A,LDA,NRB,NCB,B,LDB,NRC,NCC,C,LDC)
C  This routine computes the Kronecker product of A and B and places the result
C  in C.
C  Inputs:
C  NRA    Number of rows in A
C  NCA    Number of columns in A
C  A      Matrix A
C  LDA    Leading dimension of A
C  NRB    Number of rows in B
C  NCB    Number of columns in B
C  B      Matrix B
C  LDB    Leading dimension of B
C  NRC    Number of rows in C (Must be NRA*NRB)
C  NCC    Number of columns in C (Must be NCA*NCB)
C  LDC    Leading dimension of C
C  Output:
C  C      Matrix C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(LDA,NCA),B(LDB,NCB),C(LDC,NCC)
      IF((NRA*NRB).NE.NRC)GO TO 20
      IF((NCA*NCB).NE.NCC)GO TO 30
      IRC=0
      DO 10 IRA=1,NRA
      DO 10 IRB=1,NRB
      IRC=IRC+1
      ICC=0
      DO 10 ICA=1,NCA
      DO 10 ICB=1,NCB
      ICC=ICC+1
   10 C(IRC,ICC)=A(IRA,ICA)*B(IRB,ICB)
      RETURN
   20 WRITE(6,25)NRA,NRB,NRC
   25 FORMAT
     1  (/,' Order error in UCROSS.  NRA =',I3,' NRB =',I3,'NRC =',I4)
      STOP
   30 WRITE(6,35)NCA,NCB,NCC
   35 FORMAT
     1  (/,' Order error in UCROSS.  NCA =',I3,' NCB =',I3,'NCC =',I4)
      STOP
      END
