      DOUBLE PRECISION FUNCTION UQUAF(N,X,A,LDA)
C  This routine forms the quadratic form Q = x'Ax, A being symmetric.
C  Inputs:
C  N         Dimension of x and order of A
C  X         x vector
C  A         A matrix
C  LDA       Leading dimension of A in calling program
C  Outputs:
C  UQUAF     x'Ax
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N),A(LDA,N)
      AA=0.0D0
      DO 10 I=1,N
      DO 10 J=1,I
      BB=X(I)*A(J,I)*X(J)
      AA=AA+BB
   10 IF(J.LT.I)AA=AA+BB
      UQUAF=AA
      RETURN
      END
