      SUBROUTINE URNMVN(K,U,LDU,X)
C  This routine generates one pseudo-random vector from a multivariate
C  normal distribution with mean 0 and variance UU'.
C  References:  This routine patches up some anomolies in the IMSL library.
C  Update history:  Brought into ulib January 21, 1992.
C  Inputs:
C  K       Length of normal random vector
C  U       Upper triangular K x K matrix U: UU' = Variance of normal
C  LDU     Leading dimension of U in calling routine
C  Output:
C  X       Random draw from N(0, UU')
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(LDU,K),X(K)
      CALL DSET(K,0.0D0,X,1)
      DO 10 J=1,K
      EPS=DRNNOF()
      DO 10 I=1,J
   10 X(I)=X(I)+U(I,J)*EPS
      RETURN
      END
