      SUBROUTINE VECLT(N,A,LDA,B)
C  This routine vectorizes the lower triangle of a square matrix of order N.
C  The first N elements of the vector contain the first column of A,
C  the next N-1 elements of the vector contain the last N-1 elements of the
C  second column of A, ... , the next N-j elements of the vector contain
C  the last N-j elements of the (j+1)'th column of A, ..., and the last 
C  element of the vector contains the element in the last row and column of A.
C  Inputs:
C  N       Order of input matrix
C  A       Input matrix whose lower triangle is to be vectorized
C  LDA     Leading dimension of A in calling program
C  Outputs:
C  B       Vectorized lower triangle of A
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(LDA,N),B(100)
      L=0
      DO 10 JN=1,N
      DO 10 IN=JN,N
      L=L+1
   10 B(L)=A(IN,JN)
      RETURN
      END

C
