      SUBROUTINE WISH0(NFILE,M,TITLE,SIG0,LDSIG,ANU0,ANORM,P,LDP,A,LDA)
C  This routine reads in a matrix parameter S0 and degress of freedom
C  parameter ANU0, for the distribution  H ~ W[S0^-1, ANU0].
C  (For an unambiguous definition of the Wishart distribution, see WISHK.)
C  This routine reads in the matrix and degrees-of-freedom parameter of
C  an m x m matrix with a Wishart distribution.  In computes and returns
C  the normalizing constant of the density, a related matrix for use in
C  drawing from the distribution, and one draw from the distribution.
C  Inputs:
C  NFILE   File number for reading input information
C  M       Order of matrix, m
C  LDSIG   Leading dimension of SIG0
C  LDP     Leading dimension of P
C  LDA     Leading dimension of A
C  Outputs:
C  SIG0    Matrix parameter, Sigma
C  ANU     Degrees of freedom parameter, Nu
C  ANORM   Log normalizing constant for distribution
C  P       Upper triangr triangular mxm matrix: PP'=S0
C  A       Drawing from distribution
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*(*) TITLE
      PARAMETER(LD=100)
      COMMON/SCRA/V1(LD),V2(LD),A1(LD,LD),A2(LD,LD)
      COMMON/CONST/DLOG2,DLGPI,HLG2PI,PI,PII,GAUCON,REAL_CONSTANT_MAX
      DIMENSION A3(LD,LD)
      DM=M
      READ(NFILE,*,END=110,ERR=120)ANU0
      WRITE(6,20)TITLE,ANU0
   20 FORMAT(/,' Wishart prior distribution for ',A,/,' with',1PE16.7,
     1  ' degrees of freedom')
      IF(ANU0.LE.DM)GO TO 130
      CALL PDSYMR(NFILE,M,SIG0,LDSIG)
      CALL DLINDS(M,SIG0,LDSIG,A3,LD)
      ANORM=WISHN(M,A3,LD,ANU0,P,LDP)
      CALL WISH(M,A3,LD,ANU0,A,LDA)
      CALL PRSYM('Matrix parameter S0: H~W[S0^-1, ANU0]',M,SIG0,LDSIG)
      CALL PRSYM('Inverse of matrix parameter S0',M,A3,LD)
      CALL PRSYM('Initial draw of H',M,A,LDA)
      CALL DLINDS(M,A,LDA,A1,LD)
      CALL PRSYM('Inverse of initial draw of H',M,A1,LD)
      RETURN
  110 CALL PEND('UNANTICIPATED END-OF-FILE READING WISHART PRIOR')
  120 CALL PEND('ERROR READING WISHART PRIOR DEGREES OF FREEDOM')
  130 CALL PINTR('WISHART DEGREES OF FREEDOM',ANU0,DM,REAL_CONSTANT_MAX)
      END
      
