#include "struct.h"
#include "paramE.h"
#include "like.h"
int nObs;
double LB=0;
int **powerset[numpMAX];
dataVars *data;
int nn=numpMAX;
int nm=maxNumCoal;
double zero=0;
double doubleone=1;
int zeroint=0;
int one=1;
int transformed=1;

void gradLogLike(long int *numParam, double param[], double grad[])
{
      double v[*numParam];
      double eps=zero;
      

      DSET(numParam,&doubleone,v,&one);
      DCDGRD(logLikelihood,numParam,param,v,&eps,grad);
      
}

main()
{
  long int numParam, iparam[7]={0};
  double *param, *modalParam, modalValue, logLike,*vs,rparam[7];
  int i, samp, cNum;
  struct timeval tp;
  long s1, s2;
  double s, tolerance;
  long maxfcn=10000000;
  char outfile[20];
  FILE *in = fopen(DATAFILE, "r");
  FILE *out1;
  FILE *out2;

  fscanf(in,"%d",&samp);
  data=(dataVars *)malloc(samp * sizeof(dataVars));
  fclose(in);

  scanf("%lf %le",&s,&tolerance);
  scanf("%d",&cNum);
  scanf("%d",&numParam);
  param=(double *)malloc(numParam*sizeof(double));
  modalParam=(double *)malloc(numParam*sizeof(double));
  vs=(double *)malloc(numParam*sizeof(double));
  for (i=0; i < numParam; i++)
     scanf("%le",&param[i]);
  scanf("%s", &outfile);
  out1=fopen(outfile,"w");
  fprintf(out1,"tolerance %15.8e starting flatness %15.8e\n", tolerance,s);
  fprintf(out1,"starting point \n");
  for (i=0; i < numParam; i++) 
  fprintf(out1,"%d %lf\n",i,param[i]);
  nObs = initData(data,&LB,cNum,1);
  printf("******************************************\n%d\n",nObs);
  printf("******************************************\n");
  alloc_powerset(powerset, numpMAX);
  gen_powerset(powerset, numpMAX);

  gettimeofday(&tp, NULL );
  s1=tp.tv_sec;
  s2=tp.tv_usec;

  if (s<=0) 
     printf("Error in scale\n");
  else {
     param[RHO]=log(param[RHO]);
     param[BETA]=log(param[BETA]/(1-param[BETA]));
     DUMPOL(logLikelihood,&numParam,param,&s,&tolerance,
            &maxfcn,modalParam,&modalValue); 
/*
     for (i=0; i < numParam; i++) 
        vs[i]=0.0001;
     DUMIDH(logLikelihood,gradLogLike,&numParam,param,vs,&s,iparam,
            rparam,modalParam,&modalValue); 
*/
     gettimeofday(&tp, NULL );
     s2=tp.tv_sec-s1;
     printf("maximized likelihood in %d seconds and %d number of iterations\n\n",
             s2, maxfcn);
     out2 = fopen("inFit", "w");
     fprintf(out2, "%d \n",numParam);
     fprintf(out1,"modal value %lf\n\n",-modalValue);
     DCOPY(&numParam,modalParam, &one, param,&one);
     param[RHO]=exp(param[RHO]);
     param[BETA]=exp(param[BETA]);
     param[BETA]=param[BETA]/(1+param[BETA]);
     for (i=0; i < numParam; i++) {
        printf("%d %lf\n",i,param[i]);
        fprintf(out1,"%d %15.8e\n",i,param[i]);
        fprintf(out2,"%15.8e\n",param[i]);
     }
     fclose(out2);
     fprintf(out1,"flatness  %15.8e \n",s);
     fclose(out1);
  }
  /* deallocate powerset */
  free_powerset(powerset, numpMAX); 
  gettimeofday(&tp, NULL );
  s2=tp.tv_sec-s1;
  printf("Total run time: %d seconds \n", s2);
} 

