#include "struct.h"
#include "paramF.h"
#include "like.h"
int nObs;
double LB=0;
int **powerset[numpMAX];
dataVars *data;
int nn=numpMAX;
int nm=maxNumCoal;
double zero=0;
double doubleone=1;
int zeroint=0;
int one=1;
int transformed=0;

double calFitDur(compVars var, double Dur0, double Dur1, int maxDur)
{
  double dur0=(Dur0-LB)/(maxDur-LB);
  double dur1=(Dur1-LB)/(maxDur-LB);

  double fitDur(double y)
  {
     double a=var.delta*(y-LB)/(maxDur-y);
     double pa;
     pa =  DBETDF(&dur1,&a,&(var.delta))-DBETDF(&dur0,&a,&(var.delta));
     pa *= var.gamma * pow(y-var.yLower, var.gamma - 1) / 
               pow(var.yBar-var.yLower, var.gamma);
     return pa;
  } 
  qgaus(fitDur, var.yStar, var.yBar);
}


void fitForm(int numParam, double param[])
{
  int i, k;
  double Bin[12]={0};
  double Form[256][13]={0};
  int form;
 
  for(i = 0; i < nObs; i++) {
     form=data[i].proposer[0];
     for(k=0; k<data[i].numP;k++) {
        data[i].proposer[0]=k;
        Form[i][(int) (floor(data[i].shares[k]*20))] += probFormateur(param,data[i]); 
     }
     data[i].proposer[0]=form;
  }
  printf("Formateur\n");
  Form[i][11]+=Form[i][12];
  for (i=0; i< nObs; i++)
     for (k=0; k < 12; k++) 
        Form[nObs][k] += Form[i][k];
  for (k=0; k < 6; k++) {
     Form[nObs][k] = (Form[nObs][2*k]+Form[nObs][2*k+1])/nObs;
     printf("%7.6f\n",Form[nObs][k]);
  }
}

void fitPossibleCoalitions(double param[], dataVars obs,
                        double payoffs[maxNumCoal],
                        double size[maxNumCoal], int types[maxNumCoal],
                        double Dur[maxNumCoal][20], double Atts[maxNumCoal][8],
                        double MeanDur[maxNumCoal],
                        int unCond, int MeanOnly,int Senate)
{
  int i,j,k;
  dataVars posObs;
  compVars var;
  double Bin[21]={0};
  double gYStar;

  for (i=1; i< 21; i++)
     Bin[i]=Bin[i-1]+91.25;
  Bin[20]=1841;
  copyObsExog(obs,&posObs);
  for(i = 0; i < pow(2, posObs.numP-1); i++)
    {
      posObs.inout[posObs.proposer[0]]=1;
      for(j = 0; j < posObs.numP; j++)
        {
          if(j< posObs.proposer[0])
            posObs.inout[j]=powerset[posObs.numP-1][i][j];
          if(j> posObs.proposer[0])
            posObs.inout[j]=powerset[posObs.numP-1][i][j-1];
        }
      setAll(&posObs);
      var.yBar=calYBar(param, posObs);
      var.yLower=calYLower(param, posObs);
      var.gamma=calGamma(param, posObs,Senate);
      var.yStar=calResCake(param[BETA], var);
      var.pi=calPi(param,posObs);
      var.delta=calDelta(param,posObs);
      payoffs[i] = calPayoff(param, var);
      size[i]=posObs.cabShare;
      types[i]=posObs.houseType;
      if (unCond) {
         gYStar= pow((var.yStar-var.yLower)/(var.yBar-var.yLower),var.gamma);
         Atts[i][7]=1;
         for (k=0; k < 7; k++) {
           Atts[i][k]=(1-gYStar)*pow(gYStar,k);
           Atts[i][7]=Atts[i][7]-Atts[i][k];
         }
         if(!MeanOnly)
            for (k=0; k < 20; k++) {
              Dur[i][k]=calFitDur(var, Bin[k], Bin[k+1],posObs.maxDur);
              Dur[i][k]=Dur[i][k] / (1-gYStar);
            }
        MeanDur[i]=var.yStar*(1-param[BETA]*gYStar);
        MeanDur[i]=MeanDur[i]/(1-gYStar);
        MeanDur[i]=MeanDur[i]/param[BETA];
      }
    }
}

void fitUnCond(int numParam, double param[], int MeanOnly, int Senate)
{
  double payoffs[maxNumCoal]={0}, size[maxNumCoal]={0}; 
  int types[maxNumCoal]={0};
  double atts[maxNumCoal][8]={0};
  double dur[maxNumCoal][20]={0};
  double meandur[maxNumCoal]={0};
  double probCoalition=0; 
  int i, j, k;
  double Atts[8]={0}, 
         Dur[20]={0}, Size[21]={0}, Types[20]={0},
         MeanAtts[4]={0}, MeanDur[4]={0};
  double Avg;
  double Bin[21]={0};
  compVars var;
  double Prob[20]={0};
  double MeanAttsObs[256]={0},MeanDurObs[256]={0},
         SizeObs[256][21]={0};
  double aa;
  int nGov=0;

  for (i=1; i< 21; i++) 
     Bin[i]=Bin[i-1]+0.05;
  for(i = 0; i < nObs; i++) {
     fitPossibleCoalitions(param, data[i], payoffs, size, types, dur, 
                           atts, meandur,1, MeanOnly, Senate);
     for(k = 0; k < pow(2, data[i].numP-1); k++) {
        probCoalition=exp(logProbCoalition(payoffs[k],payoffs,param,data[i]));
        Size[(int) (floor(size[k]*20))] += probCoalition; 
        SizeObs[i][(int) (floor(size[k]*20))] += probCoalition; 
        Types[types[k]-1] += probCoalition;
        for (j=0; j < 8; j++)
        {
           aa=probCoalition*atts[k][j];
           Atts[j]+=aa;
           aa=aa*(j+1);
           MeanAtts[0]+=aa;
           MeanAttsObs[i]+=aa;
           MeanAtts[types[k]]+=aa;
           atts[k][j]=0;
        }  
        if(!MeanOnly)
          for (j=0; j < 20; j++)
          {
             Dur[j]+=probCoalition*dur[k][j];
             dur[k][j]=0;
          }
        aa=probCoalition*meandur[k];
        MeanDur[0]+=aa;
        MeanDur[types[k]]+=aa;
        meandur[k]=0;
        MeanDurObs[i]+=aa;
        Prob[types[k]-1]+=probCoalition;
     }
     SizeObs[i][19]+=SizeObs[i][20];
     DSET(&nm,&zero,payoffs,&one);
     DSET(&nm,&zero,size,&one);
     ISET(&nm,&zeroint,types,&one);
  }
  Size[19]+=Size[20];
  printf("Overall distribution:\n");
  printf("Attempts\n");
  for (k=0; k < 8; k++) {
     Atts[k] = Atts[k]/nObs;
     if (!MeanOnly)
        printf("%7.6f\n",Atts[k]);
  }
  printf("%7.6f\n",MeanAtts[0]/nObs);
  printf("Durations\n");
  for(k=0; k<8; k++) {
     Dur[k]=(Dur[2*k]+Dur[2*k+1])/nObs;
     if (!MeanOnly)
        printf("%7.6f\n",Dur[k]);
  }
  for(k=16; k<20; k++)
     Dur[7]+=Dur[k]/nObs;
  if (!MeanOnly)
     printf("%7.6f\n",Dur[7]);
  printf("%7.6f\n",MeanDur[0]/nObs);
 
  printf("Size\n");
  Avg=0;
  for (i=0; i< nObs; i++)
     for (k=0; k < 20; k++) 
        SizeObs[nObs][k] += SizeObs[i][k];
  for (k=0; k < 20; k++) {
     SizeObs[nObs][k] = SizeObs[nObs][k]/nObs;
     Avg += 0.5*(Bin[k]+Bin[k+1])*SizeObs[nObs][k];
  }
  for (k=0; k < 10; k++) {
     SizeObs[nObs][k] = (SizeObs[nObs][2*k]+SizeObs[nObs][2*k+1]);
     if (!MeanOnly)
        printf("%7.6f\n",SizeObs[nObs][k]);
  }
  printf("%7.6f\n",Avg);

  for (k=0; k < 3; k++) {
     Types[k] = Types[k]/nObs;
     MeanDur[k+1] = MeanDur[k+1]/Prob[k];
     MeanAtts[k+1] = MeanAtts[k+1]/Prob[k];
  }
  printf("\nDistribution of government types\n");
  printf("%7.6f\n", Types[0]);
  printf("%7.6f\n",Types[1]);
  printf("%7.6f\n",Types[2]);
  fflush(stdout);

}



main()
{
  long int numParam;
  double *param, logLike, *hess, *grad, *tempMat;
  int i, samp;
  struct timeval tp;
  long s1, s2;
  int s, unCond;
  FILE *in = fopen(DATAFILE, "r");
  FILE *out = fopen("varcov", "w");
  int j, Senate;
  int TrueNObs,cNum;
  dataVars temp;

  fscanf(in,"%d",&samp);
  data=(dataVars *)malloc((samp+1) * sizeof(dataVars));
  fclose(in);
  data[samp].cNum=-1;

  scanf("%d %d",&cNum,&Senate);
  scanf("%d",&numParam);
  param=(double *)malloc(numParam*sizeof(double));
  grad=(double *)malloc(numParam*sizeof(double));
  hess=(double *)malloc(numParam*numParam*sizeof(double));
  tempMat=(double *)malloc(numParam*numParam*sizeof(double));
  for (i=0; i < numParam; i++)
     scanf("%le",&param[i]);
  
  printf("Parameter Vector:\n");
  for (i=0; i < numParam; i++)
     printf("%d %7.6f\n",i,param[i]);
  nObs = initData(data,&LB,cNum,1);
printf("******************************************\n%d\n",nObs);
printf("******************************************\n");
  fflush(stdout);
  alloc_powerset(powerset, numpMAX);
  gen_powerset(powerset, numpMAX);

  gettimeofday(&tp, NULL );
  s1=tp.tv_sec;
  s2=tp.tv_usec;

  fitForm(numParam,param);
  fitUnCond(numParam,param,0,Senate);
  /* deallocate powerset */
  free_powerset(powerset, numpMAX); 
  gettimeofday(&tp, NULL );
  s2=tp.tv_sec-s1;
  printf("Total run time: %d seconds \n", s2);
} 

