#include "struct.h"
#include "paramF.h"
#include "like.h"
int nObs;

int seed=1;
double LB=0;
int **powerset[numpMAX];
dataVars *data;
int nn=numpMAX;
int nm=maxNumCoal;
double zero=0;
double doubleone=1;
int zeroint=0;
int one=1;
int transformed=0;


void fitPossibleCoalitionsUncond(double param[], dataVars obs,
                        double payoffs[maxNumCoal],
                        double size[maxNumCoal], int types[maxNumCoal],
                        double MeanAtts[maxNumCoal],
                        double MeanDur[maxNumCoal],
                        double MeanNDur[maxNumCoal])
{
  int i,j,k;
  dataVars posObs;
  compVars var;
  double gYStar, Atts[8];

  copyObsExog(obs,&posObs);
  for(i = 0; i < pow(2, posObs.numP-1); i++)
    {
      posObs.inout[posObs.proposer[0]]=1;
      for(j = 0; j < posObs.numP; j++)
        {
          if(j< posObs.proposer[0])
            posObs.inout[j]=powerset[posObs.numP-1][i][j];
          if(j> posObs.proposer[0])
            posObs.inout[j]=powerset[posObs.numP-1][i][j-1];
        }
      setAll(&posObs);
      var.yBar=calYBar(param, posObs);
      posObs.yBar=var.yBar;
      var.yLower=calYLower(param, posObs);
      var.gamma=calGamma(param, posObs);
      var.yStar=calResCake(param[BETA], var);
      var.pi=calPi(param,posObs);
      payoffs[i] = calPayoff(param, var);
      size[i]=posObs.cabShare;
      types[i]=posObs.houseType;
      gYStar= pow((var.yStar-var.yLower)/(var.yBar-var.yLower),var.gamma);
      Atts[7]=1;
      for (k=0; k < 7; k++) {
        Atts[k]=(1-gYStar)*pow(gYStar,k);
        Atts[7]=Atts[7]-Atts[k];
      }
      MeanAtts[i]=0;
      for (k=0; k < 8; k++) 
         MeanAtts[i]+=(k+1)*Atts[k];
      MeanDur[i]=var.yStar*(1-param[BETA]*gYStar)/(1-gYStar);
      MeanDur[i]=MeanDur[i]/param[BETA];
      MeanNDur[i]=MeanDur[i]/posObs.maxDur;
    }
}


void fitUncond(int numParam, double param[], double AvgAtts[],
              double AvgDur[],
              double AvgNDur[],
              double AvgSize[], 
              double Min[],
              double MW[],
              double Surp[],
              int cNum)
{
  double payoffs[maxNumCoal]={0}, size[maxNumCoal]={0}; 
  int types[maxNumCoal]={0};
  double probCoalition; 
  int i, k, j;
  double MeanAtts[maxNumCoal]={0}, 
         Types[3]={0},Size[21]={0}, 
         Avg=0, MeanDur[maxNumCoal]={0}, MeanNDur[maxNumCoal]={0};
  double Bin[21]={0};
  compVars var;
  double gYStar;

  for (i=0; i< 10; i++) {
     AvgAtts[i]=0;
     AvgDur[i]=0;
     AvgNDur[i]=0;
     AvgSize[i]=0;
     Min[i]=0;
     MW[i]=0;
     Surp[i]=0;
  } 

  param[RHO]=exp(param[RHO]);
  param[BETA]=exp(param[BETA]);
  param[BETA]=param[BETA]/(param[BETA]+1);
  for (i=1; i< 21; i++) 
     Bin[i]=Bin[i-1]+0.05;
  
  j=1;
  for(i = 0; i < nObs; i++) {
     Types[0]=0;
     Types[1]=0;
     Types[2]=0;
     for(k=0; k< 21;k++)
         Size[k]=0;
     if ((data[i].cNum==cNum) || (cNum==-1)) {
        fitPossibleCoalitionsUncond(param, data[i], payoffs, size, types,
                             MeanAtts,MeanDur,MeanNDur);
        for(k = 0; k < pow(2, data[i].numP-1); k++) {
           probCoalition=exp(logProbCoalition(payoffs[k],payoffs,param,data[i]));
           Size[(int) (floor(size[k]*20))] += probCoalition; 
           Types[types[k]-1] += probCoalition;
           AvgAtts[j] += probCoalition*MeanAtts[k];
           AvgDur[j] += probCoalition*MeanDur[k];
           AvgNDur[j] += probCoalition*MeanNDur[k];
        }
        Size[19]+=Size[20];
        for (k=0; k < 20; k++) 
           AvgSize[j] += 0.5*(Bin[k]+Bin[k+1])*Size[k];
        Min[j]+=Types[0];
        MW[j]+=Types[1];
        Surp[j]+=Types[2];
        if(data[i].cNum!=data[i+1].cNum) 
          j++;
     }
     DSET(&nm,&zero,payoffs,&one);
     DSET(&nm,&zero,size,&one);
     ISET(&nm,&zeroint,types,&one);
  }
  for(j=1; j<10; j++) {
     AvgAtts[0]+=AvgAtts[j];
     AvgDur[0]+= AvgDur[j];
     AvgNDur[0]+= AvgNDur[j];
     AvgSize[0]+=AvgSize[j];
     Min[0]+=Min[j];
     MW[0]+=MW[j];
     Surp[0]+=Surp[j];
  }

  fflush(stdout);
}




main()
{
  long int numParam;
  double *param,*dum,*meanParam, logLike, *prec;
  int i, samp;
  struct timeval tp;
  long s1, s2;
  int s, unCond;
  FILE *in = fopen(DATAFILE, "r");
  int j, nIter, k;
  int TrueNObs;
  dataVars temp;
  double AvgAtts[10]={0}, 
         AvgDur[10]={0}, AvgNDur[10]={0}, AvgSize[10]={0}, 
         Min[10]={0}, MW[10]={0}, Surp[10]={0};
  double MeanAtts[10]={0}, MeanDur[10]={0}, MeanSize[10]={0}, MeanNDur[10]={0}, 
         MeanTypes[10][3]={0};
  double StAtts[10]={0}, StDur[10]={0}, StSize[10]={0}, StNDur[10]={0}, 
         StTypes[10][3]={0};
  double aa;
  int nGov[10]={0};
  int cNum, Senate;
  int nC=1;

  fscanf(in,"%d",&samp);
  data=(dataVars *)malloc((samp+1) * sizeof(dataVars));
  fclose(in);
  data[samp].cNum=-1;

  scanf("%d %d %d",&cNum,&nIter,&Senate);
  scanf("%d",&numParam);
  meanParam=(double *)malloc(numParam*sizeof(double));
  param=(double *)malloc(numParam*sizeof(double));
  dum=(double *)malloc(numParam*sizeof(double));
  prec=(double *)malloc(numParam*numParam*sizeof(double));
  for (i=0; i < numParam; i++)  
     scanf("%le",&meanParam[i]);

  meanParam[RHO]=log(meanParam[RHO]);
  meanParam[BETA]=log(meanParam[BETA]/(1-meanParam[BETA]));
  transformed=1;

   
  if(cNum==-1)
    nC=10;
  k=0;
  for (i=0; i < numParam; i++)
     for (j=0; j < numParam; j++) 
         scanf("%le",&(prec[k++]));
  
  RNSET(&seed);
  GAU(&numParam,meanParam,prec,&numParam,param,dum);
  nObs = initData(data,&LB,cNum,Senate); 
  nGov[0]=nObs;
  j=1;
  for(i=0; i<nObs;i++) {
    nGov[j]++; 
    if(data[i].cNum!=data[i+1].cNum){
       if(data[i].cNum==cNum)
         nGov[0]=nGov[j];
       j++;
    }
  }

  alloc_powerset(powerset, numpMAX);
  gen_powerset(powerset, numpMAX);

  gettimeofday(&tp, NULL );
  s1=tp.tv_sec;
  s2=tp.tv_usec;

  for(i=0; i< nIter; i++) {
     if(nIter>=2) 
        GAUA(&numParam,meanParam,prec,&numParam,param,dum);
     else 
        DCOPY(&numParam,meanParam,&one,param,&one);
        fitUncond(numParam,param,AvgAtts, AvgDur, AvgNDur, AvgSize, Min,MW,Surp,cNum);
     for(j=0; j<nC; j++) {
        aa = AvgAtts[j]/nGov[j];
        MeanAtts[j] += aa;
        AvgAtts[j]=0;
        StAtts[j] += aa*aa;
        aa = AvgDur[j]/nGov[j];
        MeanDur[j] += aa;
        StDur[j] += aa* aa;
        AvgDur[j]=0;
        aa = AvgNDur[j]/nGov[j];
        MeanNDur[j] += aa;
        StNDur[j] += aa* aa;
        AvgNDur[j]=0;
        aa = AvgSize[j]/nGov[j];
        MeanSize[j] += aa;
        StSize[j] += aa* aa;
        AvgSize[j]=0;
        aa = Min[j]/nGov[j];
        MeanTypes[j][0] += aa;
        StTypes[j][0] +=aa* aa;
        Min[j]=0;
        aa = MW[j]/nGov[j];
        MeanTypes[j][1] += aa;
        StTypes[j][1] +=aa* aa;
        MW[j]=0;
        aa = Surp[j]/nGov[j];
        MeanTypes[j][2] += aa;
        StTypes[j][2] += aa* aa;
        Surp[j]=0;
     }
  }

 for(j=0; j<nC; j++) {
    MeanAtts[j] = MeanAtts[j]/nIter;
    StAtts[j]=sqrt(StAtts[j]/nIter-MeanAtts[j]*MeanAtts[j]);
    MeanDur[j] = MeanDur[j]/nIter;
    StDur[j]=sqrt(StDur[j]/nIter-MeanDur[j]*MeanDur[j]);
    MeanNDur[j] = MeanNDur[j]/nIter;
    StNDur[j]=sqrt(StNDur[j]/nIter-MeanNDur[j]*MeanNDur[j]);
    MeanSize[j] = MeanSize[j]/nIter;
    StSize[j]=sqrt(StSize[j]/nIter-MeanSize[j]*MeanSize[j]);
    for(k=0; k<3; k++) {
       MeanTypes[j][k] = MeanTypes[j][k]/nIter;
       StTypes[j][k] = sqrt(StTypes[j][k]/nIter-MeanTypes[j][k]*MeanTypes[j][k]);
    }
  }


  for(j=0; j<nC; j++) {
       printf("%7.6f\t %7.6f\n",MeanAtts[j],StAtts[j]);
       printf("%7.6f\t %7.6f\n",MeanDur[j],StDur[j]);
       printf("%7.6f\t %7.6f\n",MeanSize[j],StSize[j]);
       for(k=0; k< 3; k++) 
         printf("%7.6f\t%7.6f\n",MeanTypes[j][k],StTypes[j][k]);
       printf("\n");
  }
  /* deallocate powerset */
  free_powerset(powerset, numpMAX); 
  gettimeofday(&tp, NULL );
  s2=tp.tv_sec-s1;
  printf("Total run time: %d seconds \n", s2);
} 

