#include "struct.h"
#include <stdlib.h>


void EffNumP(dataVars *obs)
{
  int k;
  obs->effNumP=0;
  for(k = 0; k < obs->numP; k++)
     obs->effNumP += (obs->shares[k] * obs->shares[k]);
  obs->effNumP = 1/obs->effNumP;
}

void EffNumPIn(dataVars *obs)
{
  int k;
  obs->effNumPin=0;
  for(k = 0; k < obs->numP; k++)
     obs->effNumPin += obs->inout[k]*(obs->shares[k] * obs->shares[k]);
  obs->effNumPin = 1/obs->effNumPin;
}

void numpIn(dataVars *obs)
{
  int k;
  obs->numpIn=0;
  for(k = 0; k < obs->numP; k++)
     obs->numpIn += obs->inout[k];
}

void medianIn(dataVars *obs)
{
  int k;
  obs->medianIn=0;
  for(k = 0; k < obs->numP; k++)
     if(obs->inout[k] && (obs->type[k]==0))
        obs->medianIn=1;
}

void extremeIn(dataVars *obs)
{
  int k;
  obs->extremeIn=0;
  for(k = 0; k < obs->numP; k++)
     if(obs->inout[k] && obs->extreme[k])
        obs->extremeIn=1;
}

void cabShare(dataVars *obs)
{
  int k;
  obs->cabShare=0;
  for(k = 0; k < obs->numP; k++)
     obs->cabShare += obs->inout[k]*obs->shares[k];
}

void senCabShare(dataVars *obs)
{
  int k;
  obs->senCabShare=0;
  for(k = 0; k < obs->numP; k++)
     obs->senCabShare += obs->inout[k]*obs->senShares[k];
}

void houseType(dataVars *obs)
{
  int k;
  if (rint(obs->cabShare * 1000) < 500)
     obs->houseType=1;
  else
  {
     obs->houseType=2;
     for(k = 0; k < obs->numP; k++)
        if( (obs->inout[k]==1) && (rint(1000*(obs->cabShare-obs->shares[k])) >= 500))
           obs->houseType=3;
  }
}

void senateType(dataVars *obs, int Senate)
{
  obs->senType=0;
  if (rint(1000*obs->senCabShare) >= 500)
     obs->senType=1;
  if (!Senate)
     obs->senType=1;
}

void govtType(dataVars *obs)
{
  int k, left=1, right=1;

  for (k=0; k < obs->numP; k++) {
     if(obs->inout[k] && (obs->type[k]==1))
       left=0;
     if(obs->inout[k] && (obs->type[k]==-1))
       right=0;
  }
  obs->govType=1;
  if(left && !right)
     obs->govType=2;
  if(!left && right)
     obs->govType=3;
  if(!left && !right)
     obs->govType=4;
}

void setAll(dataVars *obs, int Senate)
{
   cabShare(obs);
   numpIn(obs);
   medianIn(obs);
   extremeIn(obs);
   houseType(obs);
   govtType(obs);
   EffNumP(obs);
   EffNumPIn(obs);
   govtType(obs);
   if(obs->senate) {
     senCabShare(obs);
     senateType(obs,Senate);
   }
}
int initData(dataVars data[], double *LB, int cNum, int Senate)
{
  FILE *in = fopen(DATAFILE, "r");

  int i, j,k, l;
  int samp=0;
  int done;
  
  fscanf(in,"%d",&samp);
  
  i=0;
  for(l=0; l < samp; l++) {
     fscanf(in,"%d%d%d%d%d%d%d%d%d%d%d%d%le%le%le%d",
             &(data[i].cNum),&(data[i].govt),&(data[i].nAtt), &(data[i].dur),
             &(data[i].maxDur),&(data[i].numP),&(data[i].invest),
             &(data[i].postElec),&(data[i].cConf),&(data[i].senate),&(data[i].eel),
             &(data[i].year),&(data[i].gdpGrowth),&(data[i].inflation),
             &(data[i].gdp), &(data[i].np));
     for (j=0; j < data[i].numP; j++)
     {
        fscanf(in,"%d%lf%d%d%d%d%d%d",&(data[i].MR[j]),&(data[i].shares[j]),
                                  &(data[i].inout[j]),&(data[i].incum[j]),
                                  &(data[i].form[j]),&(data[i].type[j]),
                                  &(data[i].extreme[j]),&(data[i].constraint[j]));
        if(data[i].senate) 
             fscanf(in,"%lf",&(data[i].senShares[j]));
     }
     for(j=0; j < data[i].nAtt; j++) {
        done=0;
        fscanf(in,"%d",&(data[i].proposer[j]));
        for (k=0; k<data[i].numP;k++)
           if((!done) && (data[i].MR[k]==data[i].proposer[j])) {
              done=1;
              data[i].proposer[j]=k;
           }
     }
     setAll(&(data[i]), Senate);
     if(data[i].cNum==cNum)
        i++;
  }
  samp=i;
  *LB=0;
  fclose(in);
  return samp;
} 

void copyObsExog(dataVars obs1, dataVars *obs2)
{
   int j;
   
   obs2->cNum=obs1.cNum;
   obs2->govt=obs1.govt;
   obs2->maxDur=obs1.maxDur;
   obs2->numP=obs1.numP;
   obs2->invest=obs1.invest;
   obs2->postElec=obs1.postElec;
   obs2->cConf=obs1.cConf;
   obs2->senate=obs1.senate;
   obs2->year=obs1.year;
   obs2->gdpGrowth=obs1.gdpGrowth;
   obs2->inflation=obs1.inflation;
   obs2->eel=obs1.eel;
   obs2->np=obs1.np;
   obs2->gdp=obs1.gdp;
   obs2->effNumP=obs1.effNumP;
   for (j=0; j < obs2->numP; j++) {
        obs2->MR[j]=obs1.MR[j];
        obs2->shares[j]=obs1.shares[j];
        if (obs2->senate)
           obs2->senShares[j]=obs1.senShares[j];
        obs2->incum[j]=obs1.incum[j];
        obs2->type[j]=obs1.type[j];
        obs2->extreme[j]=obs1.extreme[j];
        obs2->constraint[j]=obs1.constraint[j];
        obs2->form[j]=obs1.form[j];
   }
  obs2->proposer[0]=obs1.proposer[0];
}


void copyObsEndog(dataVars obs1, dataVars *obs2)
{
   int j;
   
   obs2->cabShare=obs1.cabShare;
   obs2->senCabShare=obs1.senCabShare;
   obs2->nAtt=obs1.nAtt;
   obs2->dur=obs1.dur;
   obs2->medianIn=obs1.medianIn;
   obs2->extremeIn=obs1.extremeIn;
   obs2->govType=obs1.govType;
   obs2->houseType=obs1.houseType;
   obs2->senType=obs1.senType;
   obs2->effNumPin=obs1.effNumPin;
   for (j=0; j < obs2->numP; j++) 
        obs2->inout[j]=obs1.inout[j];
   for (j=0; j < obs2->nAtt; j++) 
       obs2->proposer[j]=obs1.proposer[j];
}

