#include "struct.h"
#include "paramF.h"
#include <math.h>
#include <stdio.h>

double calGamma(double param[], dataVars obs)
{
  double gamma;
  int min=0, mw=0, surp=0;

  if(obs.houseType==1)
     min=1;
  else if (obs.houseType==2) 
     mw=1;
  else 
     surp=1;
  gamma=min*(param[GAMMA0]+ param[GAMMA1]*obs.cabShare);
  gamma+=mw*(param[GAMMA3]+  param[GAMMA4]*obs.cabShare);
  gamma+=surp*(param[GAMMA6]+param[GAMMA7]*obs.cabShare);
  gamma+=param[GAMMA9]*obs.maxDur/2000;
  gamma+=param[GAMMA10]*obs.senType;
  return exp(gamma);
}

double calDelta(double param[], dataVars obs)
{
  double delta;
  delta=param[DELTA0] +obs.maxDur*param[DELTA1]/2000;
  return exp(delta);
}

double logFormateur(double param[], dataVars obs)
{
  int i;
  double denom=0;
  double A1=param[ALPHA1];
  double A2=param[ALPHA2];

  if (rint(1000*obs.shares[obs.proposer[0]]) >= 500)
     return 0;
  else if (rint(1000*obs.senShares[obs.proposer[0]]) >= 500)
     return 0;
  else
    for(i = 0; i < obs.numP; i++)
      denom += exp(obs.shares[i] * A1 + obs.incum[i] * A2);
  return obs.shares[obs.proposer[0]]*A1 +
         obs.incum[obs.proposer[0]]*A2-log(denom);
}

double probFormateur(double param[], dataVars obs)
{
  int i;
  double num, denom=0;
  double A1=param[ALPHA1];
  double A2=param[ALPHA2];

  if (rint(1000*obs.shares[obs.proposer[0]]) >= 500)
     return 1;
  else if (rint(1000*obs.senShares[obs.proposer[0]]) >= 500)
     return 1;
  else {
    num=exp(obs.shares[obs.proposer[0]]*A1 +
         obs.incum[obs.proposer[0]]*A2);
    for(i = 0; i < obs.numP; i++)
       if(i!=obs.proposer[0]) {
       if (rint(1000*obs.shares[i]) >= 500)
          return 0;
       else if (rint(1000*obs.senShares[i]) >= 500)
          return 0;
       else
          denom += exp(obs.shares[i] * A1 + obs.incum[i] * A2);
       }
    return num/(num+denom);
  }
}

double calYBar(double param[], dataVars obs)
{
  double lambda;
  
  lambda=param[LAMBDAH1];
  lambda=exp(lambda);

  return obs.maxDur*lambda/(lambda+1);
}

double calYLower(double param[], dataVars obs)
{
  return 0;
}

double logProbCoalition(double winningPayoff, double payoffs[], double param[], dataVars obs)
{
  int i;
  double denom=0;
  for(i=0; i<pow(2,obs.numP-1); i++)
     denom += exp(payoffs[i]/(param[RHO]*2000));
  return winningPayoff/(param[RHO]*2000)-log(denom);
}

double calPi(double param[], dataVars obs)
{
   int i;
   double num, denom=0;

  if (rint(1000*obs.shares[obs.proposer[0]]) >= 500)
      return 1;
  else if (rint(1000*obs.senShares[obs.proposer[0]]) >= 500)
     return 1;
   else {
      num=exp(obs.shares[obs.proposer[0]]*param[ALPHA3]);
      for(i = 0; i < obs.numP; i++)
         if(i!=obs.proposer[0])
           denom += obs.inout[i]* exp(obs.shares[i]*param[ALPHA3]);
      return num/(num+denom);
   }
}

double calPiDenom(double param[], dataVars obs)
{
   int i;
   double denom=0;

  if (rint(1000*obs.shares[obs.proposer[0]]) >= 500)
     return 1;
  else if (rint(1000*obs.senShares[obs.proposer[0]]) >= 500)
     return 1;
   for(i = 0; i < obs.numP; i++)
      denom += obs.inout[i]* exp(obs.shares[i]*param[ALPHA3]);
   return denom;
}

double calLogPiNum(double param[], dataVars obs, int i)
{
  if (rint(1000*obs.shares[obs.proposer[0]]) >= 500)
     return 0;
  else if (rint(1000*obs.senShares[obs.proposer[0]]) >= 500)
     return 0;
   return obs.shares[i]*param[ALPHA3];
}
