#include "struct.h"
#include "paramE.h"
#include "like.h"
int nObs;
double LB=0;
int **powerset[numpMAX];
dataVars *data;
int nn=numpMAX;
int nm=maxNumCoal;
double zero=0;
double doubleone=1;
int zeroint=0;
int one=1;
int transformed=0;




void gradLogLike(long int *numParam, double param[], double grad[])
{
      double v[*numParam];
      double eps=zero;

      DSET(numParam,&doubleone,v,&one);
      DCDGRD(logLikelihood,numParam,param,v,&eps,grad);
      
}

void hessLogLike(long int *numParam, double param[], double hess[], long int *lda)
{

      double v[*numParam], logLike;
      double eps=zero;
      int i,j;
      double grad[*numParam];

      logLikelihood(numParam, param, &logLike);
      DSET(numParam,&doubleone,v,&one);
      DFDHES(logLikelihood,numParam,param,v,&logLike,&eps,hess,lda);

      for (i=0; i< *numParam; i++)
         for (j=0; j< i; j++)
            hess[i* *numParam+ j]=hess[j* *numParam+ i];
}


main()
{
  long int numParam;
  double *param, logLike, *hess, *grad, *tempMat;
  int i, samp;
  struct timeval tp;
  long s1, s2;
  int numpvar;
  FILE *in = fopen(DATAFILE, "r");
  FILE *out = fopen("varcov", "w");
  int j;
  int TrueNObs;
  dataVars temp;

  fscanf(in,"%d",&samp);
  data=(dataVars *)malloc((samp+1) * sizeof(dataVars));
  fclose(in);
  data[samp].cNum=-1;

  scanf("%d %d",&numpvar,&transformed);
  scanf("%d",&numParam);
  param=(double *)malloc(numParam*sizeof(double));
  grad=(double *)malloc(numParam*sizeof(double));
  hess=(double *)malloc(numParam*numParam*sizeof(double));
  tempMat=(double *)malloc(numParam*numParam*sizeof(double));
  for (i=0; i < numParam; i++)
     scanf("%le",&param[i]);
  
/*
  param[LAMBDAH1]=exp(param[LAMBDAH1])/(1+exp(param[LAMBDAH1]));
*/
  if(transformed) {
     param[RHO]=log(param[RHO]);
     param[BETA]=log(param[BETA]/(1-param[BETA]));
  }

  printf("Parameter Vector:\n");
  for (i=0; i < numParam; i++)
     printf("%d %7.6f\n",i,param[i]);
  nObs = initData(data,&LB,1);
printf("******************************************\n%d\n",nObs);
printf("******************************************\n");
  fflush(stdout);
  alloc_powerset(powerset, numpMAX);
  gen_powerset(powerset, numpMAX);

  gettimeofday(&tp, NULL );
  s1=tp.tv_sec;
  s2=tp.tv_usec;


     copyObsExog(data[0],&temp);
     copyObsEndog(data[0],&temp);
     TrueNObs=nObs;
     nObs=1;
     for (j=0; j < numParam*numParam; j++)
         hess[j]=0;
     for (i=0;i<TrueNObs;i++) {
        copyObsExog(data[i],&(data[0]));
        copyObsEndog(data[i],&(data[0]));
        gradLogLike(&numParam, param, grad);
        DMXTXF(&one,&numParam,grad,&one,&numParam,tempMat,&numParam);
        for (j=0; j < numParam*numParam; j++)
            hess[j]+=tempMat[j];
     }
     copyObsExog(temp,&(data[0]));
     copyObsEndog(temp,&(data[0]));
     nObs=TrueNObs;
     logLikelihood(&numParam, param, &logLike);
     printf("\nlog likelihood: %lf\n\n", logLike);
     for (i=0; i < numpvar; i++){
        fprintf(out,"0 0 ");
        for (j=0; j < numpvar; j++)
           fprintf(out,"%7.6e  ",hess[i*numParam+ j]);
        fprintf(out,"\n");

     }
     DLINRG(&numParam,hess,&numParam,hess,&numParam);
     printf("standard errors using outer products\n\n");
     for (i=0; i < numParam; i++)
        printf("%d %15.8e \n",i,sqrt(hess[i*(numParam+1)]));
  /* deallocate powerset */
  free_powerset(powerset, numpMAX); 
  gettimeofday(&tp, NULL );
  s2=tp.tv_sec-s1;
  printf("Total run time: %d seconds \n", s2);
  fflush(out);
  fclose(out);
} 

