#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>
#include <math.h>
#include "pset.h"

#define numpMAX                     13      /* maximum number of parties */
#define attMAX                      7       /* maximum number of attempts */
#define maxNumCoal                  4096   /* maxNumCoal = 2^(numpMAX - 1) */
#define maxTotCoal                  37216  /* sum of maxNumCoal = 2^(numpMAX - 1) */
#define DATAFILE                    "/home/hulya/Merlo/july01final_econ.txt" 


typedef struct
{
  double cabShare;
  double shares[numpMAX];
  double senShares[numpMAX];
  double senCabShare;
  double logPiNum[numpMAX];
  double piDenom;
  double gdpGrowth;
  double inflation;
  double effNumP;
  double effNumPin;
  double gdp;
  int year;
  int MR[numpMAX];
  int inout[numpMAX];
  int incum[numpMAX];
  int form[numpMAX];
  int type[numpMAX];
  int extreme[numpMAX];
  int constraint[numpMAX];
  int proposer[attMAX];
  int cNum;
  int govt;
  int nAtt;
  int dur;
  int maxDur;
  int postElec;
  int numP;
  int invest;
  int cConf;
  int senate;
  int eel;
  int medianIn;
  int extremeIn;
  int numpIn;
  int govType;
  int houseType;
  int senType;
  double yBar;
  int np;
} dataVars;

typedef struct
{
  double yBar;
  double yLower;
  double gamma;
  double delta;
  double yStar;
  double pi;
} compVars;

double DGAMMA(double *x);
double DGAMR(double *x);
double DLNGAM(double *x);
double DBETDF(double *x, double *pin, double *qin);
double qgaus(double (*func)(double), double a, double b);
