** Data files belgium, sweden and denmark contain the following variables:
** cnum = country id (1=belgium, 2=denmark, 12=sweden)
** gov = unique government identifier for each country 1,2,3,...
** atts = number of government formation attempts
** dur = government duration (in days)
** maxdur = time to next election (in days)
** nump = number of parties
** senate = dummy for Senate (1=Senate present, 0=Senate not present)
** houseshr = size of government coalition (% in House)
** senshr = size of government coalition (% in Senate)
** housety = type of government in the House (1=minority, 2=minimum winning, 3=surplus)
** sentype = type of government in the Senate (1=majority, 0=minority)
** min = dummy for minority government in the House
** minwin = dummy for minimum winning government in the House
** surp = summy for surplus government in the House
** majsen = dummy for majority government in the House

** change directory in stata to the directory where the data files are located

log using summary_statistics.out,replace text
use belgium
set more off

** generate Table 1
su atts dur maxdur nump houseshr senshr min minwin surp majsen

** generate data column for Table 3
tab atts

** generate data column for Table 4
gen ydur=recode(dur,182.5,182.5*2,182.5*3,182.5*4,182.5*5,182.5*6,182.5*7,182.5*8)
tab ydur

** generate data column for Table 5
gen cabshr=recode(houseshr,10,20,30,40,50,60,70,80,90,100)
tab cabsh

** generate data column for Table 6
tab housety

** Actual column in Table 7 is taken from Table 1

drop _all

use sweden

** generate Before 1970 column in Table 8
su atts dur houseshr min minwin surp if senate==1


** generate After 1970 column in Table 8
su atts dur houseshr min minwin surp if senate==0

drop _all

use denmark

** generate Actual column in Table 9
su atts dur houseshr min minwin surp

drop _all
log close
